#!/usr/bin/perl -w
#
# create.pl - Creates pages for antims site
#########################################################

my $dir = '/home/stan/html/antims/roundup';
my $database = "$dir/database.txt";

my %X;
my %COUNTS;

ReadDatabase();
OutputFiles();

   
sub OutputFiles {
   foreach my $cat ( keys %X ) {
      my( $subdir, $section ) = split /\//, $cat, 2;
      my $infile = "$dir/$subdir/template.shtml";
      my $outfile = "$dir/$subdir/index.shtml";
      DoSingleFile( $infile, $outfile );
   }      
   DoSingleFile( "$dir/template.shtml", "$dir/index.shtml" );
}

sub DoSingleFile {
   my( $infile, $outfile ) = @_;
   open IN, $infile or die "Error reading $infile... $!\n";
   local $/; undef $/; my $html = <IN>; close IN;
      
   $html =~ s{<!--\@INSERT "(.*?)"\s*-->}{InsertLinks($1)}ge;
   $html =~ s{<!--\@COUNT "(.*?)"\s*-->}{CountLinks($1)}ge;
     
   open OUT, ">$outfile" or die "Error writing $outfile... $!\n";
   print OUT $html;
   close OUT;
}

sub InsertLinks {
   my $cat = shift;
   my $OUT = "<UL>\n";
   ITEM: foreach my $item ( @{$X{$cat}} ) {
      if( defined $item->{'defunct'} ) { next ITEM; }
      my $link = $item->{'url'} || 'ERROR';
      my $title = $item->{'title'} || 'ERROR';
      my $bold = $item->{'cool'} || '';
      my $ahref = "<A HREF=\"$link\">$title</A>";
      if( $bold ) {
         $ahref = "<B>$ahref</B>";
      }
      $OUT .= "<LI>$ahref";
      if( defined $item->{'source'} ) {
         $OUT .= " <FONT COLOR=\"#666666\">($item->{'source'})</FONT>";
      }
      my $desc = $item->{'desc'} || '';
      if( $desc ) {
         $desc = StripWhitespace( $desc );
         $OUT .= " - $desc";
      }
      if( defined $item->{'format'} ) {
         $OUT .= " <FONT COLOR=\"#666666\">($item->{'format'})</FONT>";
      }

      $OUT .= "\n";
   }
   return "$OUT</UL>\n";
}

sub CountLinks {
   my $cat = shift;
   my $out = 0;
   if( defined $COUNTS{$cat} ) {
      return $COUNTS{$cat};
   }
   if( $cat eq '/' ) {
      foreach my $s ( keys %X ) {
         $out += $#{ $X{$s} } + 1;
      }
   } elsif( $cat =~ m{/} ) {
      $out = $#{ $X{$cat} } + 1;
   } else {
      foreach my $s ( keys %X ) {
         my( $s1, undef ) = split /\//, $s;
         if( $cat eq $s1 ) {
            $out += $#{ $X{$s} } + 1;
         }
      }
   }      
   $COUNTS{$cat} = $out;
   return $out;
}

sub ReadDatabase {
   open IN, $database or die "Error opening $database... $!\n";
   local $/; undef $/; my $txt = <IN>; close IN;

   while( $txt =~ m{<site category="(.*?)">(.*?)</site>}gis ) {
      my $cat = $1; $site = $2;
      my %temp;
      while( $site =~ m{<(.*?)>(.*?)</\1>}gis ) {
         $temp{$1} = $2;
      }
      push( @{$X{$cat}}, { %temp } );
   }
}

sub StripWhitespace {
   my $work = shift;
   $work =~ s/^\s+//;
   $work =~ s/\s+$//;
   return $work;
}
